/***
*** 
***/
#ifndef VUMISCFUNS_H
#define VUMISCFUNS_H

#include "std.h"
#include "dvstd.h"

#include "dvtools.h"
#include "VOstd.h"
#include "dvGR.h"


/* VU/VUarray.c */
ADDRESS VUgetArrayElem V_P_((ADDRESS *Array,  LONG ElemSize,
	 LONG *ArraySize,  LONG Index));
BOOLPARAM VUsetArrayElem V_P_((ADDRESS *Array,  LONG ElemSize,
	 LONG *ArraySize,  LONG Index,  ADDRESS NewElem,  LONG Delta));

/* VU/VUatom.c */
char *VUInternString V_P_((char *string));

/* VU/VUconfgdat.c */
void VUconfigDataInit V_P_((void));

/* VU/VUconfig.c */
BOOLPARAM VUconfigInit V_P_((int num_names,  ADDRESS com[]));
BOOLPARAM VUconfigTerm V_P_((int num_names,  ADDRESS com[]));
BOOLPARAM VUconfigGet V_P_((char *filename,  int num_names,  ADDRESS vars,
	 ADDRESS com[]));

/* VU/VUcpyright.c */
void VUcopyright V_P_((void));

/* VU/VUdevice.c */
int VUopendev_clut V_P_((char name[], char *clutfile));
int VUopendev_set V_P_((char *name, char *clutfile, ...));
int VUopendevice V_P_((char name[]));
void VUon_copyright V_P_((void));
void VUoff_copyright V_P_((void));
void VUclosedevice V_P_((int LogicalDevice));
int VUgetdevnum V_P_((int LogicalDevice));
int VUgetdevindex V_P_((int PhysicalDevice));
int VUrgbtoindex V_P_((int LogicalDevice,  int r,  int g,  int b));
void VUindextorgb V_P_((int LogicalDevice,  int index,  int *r,  int *g,
	 int *b));
void VUloadclut V_P_((char *filename));
void VUsetdevtbls V_P_((short *logical_tbl,  short *phys_tbl,
	 int vu_numdev));

/* VU/VUdvstd.c */
RGB_SPEC *VUrgbCreate V_P_((void));
void VUrgbDelete V_P_((RGB_SPEC *rgb));
void VUrgbPutFields V_P_((RGB_SPEC *rgb,  int rgb_rep_flag,  int blue,
	 int green,  int red));
void VUrgbGetFields V_P_((RGB_SPEC *rgb,  char *rgb_rep_flag,  char *blue,
	 char *green,  char *red));
COLOR_SPEC *VUcspCreate V_P_((void));
void VUcspDelete V_P_((COLOR_SPEC *csp));
void VUcspPutFields V_P_((COLOR_SPEC *csp,  LONG color_index,
	 RGB_SPEC *rgb_rep));
void VUcspGetFields V_P_((COLOR_SPEC *csp,  LONG *color_index,
	 RGB_SPEC *rgb_rep));
COLOR_THRESHOLD *VUcltCreate V_P_((void));
void VUcltDelete V_P_((COLOR_THRESHOLD *clt));
void VUcltPutFields V_P_((COLOR_THRESHOLD *clt,  int upperlimit,
	 COLOR_SPEC *threshcolor));
void VUcltGetFields V_P_((COLOR_THRESHOLD *clt,  int *upperlimit,
	 COLOR_SPEC *threshcolor));
PLR_POINT *VUplrCreate V_P_((void));
void VUplrDelete V_P_((PLR_POINT *plr));
void VUplrPutFields V_P_((PLR_POINT *plr,  int radius,  int angle));
void VUplrGetFields V_P_((PLR_POINT *plr,  int *radius,  int *angle));
DV_POINT *VUpntCreate V_P_((void));
void VUpntDelete V_P_((DV_POINT *pnt));
void VUpntPutFields V_P_((DV_POINT *pnt, DV_COORD x, DV_COORD y));
void VUpntGetFields V_P_((DV_POINT *pnt, DV_COORD *x, DV_COORD *y));
RECTANGLE *VUrecCreate V_P_((void));
void VUrecDelete V_P_((RECTANGLE *rec));
void VUrecPutFields V_P_((RECTANGLE *rec,  DV_COORD ll_x,  DV_COORD ll_y,
	 DV_COORD ur_x,  DV_COORD ur_y));
void VUrecGetFields V_P_((RECTANGLE *rec,  DV_COORD *ll_x,  DV_COORD *ll_y,
	 DV_COORD *ur_x,  DV_COORD *ur_y));

/* VU/VUexit.c */
/* -- in std.h: void VUexit V_P_((int status)); */

/* VU/VUfcheck.c */
int VUfread_check V_P_((char *filename));
int VUfwrite_check V_P_((char *filename));
int VUfexist_check V_P_((char *filename));

/* VU/VUinitHpSz.c */
void VUinitInitialHeapSize V_P_((ADDRESS com[]));

/* VU/VUmem.c */
/* -- in std.h: void VUfree V_P_((ADDRESS addr)); */
/* -- in std.h: ADDRESS VUmalloc V_P_((LONG size)); */
/* -- in std.h: ADDRESS VUrealloc V_P_((ADDRESS ptr, LONG size)); */

/* VU/VUmessage.c */
BOOLPARAM VUmsgAdd V_P_((ADDRESS tap,  char *text,  int color));
BOOLPARAM VUmsgDelete V_P_((ADDRESS tap,  LONG m1,  LONG m2));
BOOLPARAM VUmsgClear V_P_((ADDRESS tap));
BOOLPARAM VUmsgDisplay V_P_((ADDRESS tap,  LONG first,  BOOLPARAM scr,
	 RECTANGLE **vplist));
int VUmsgInit V_P_((ADDRESS tap,  LONG initsize,  LONG initnmsg,
	 LONG delta));
BOOLPARAM VUmsgTerm V_P_((ADDRESS tap));
int VUmsgHandle V_P_((ADDRESS tap));

/* VU/VUrand.c */
void VUsrand V_P_((int seed));
LONG VUrand V_P_((void));
double VUfrand V_P_((void));

/* VU/VUsrchPath.c */
BOOLPARAM VUsetSearchPath V_P_((char *SearchPath));
BOOLPARAM VUaddSearchPath V_P_((char *Path,  BOOLPARAM Append));
BOOLPARAM VUgetSearchPath V_P_((char **SearchPath));

/* VU/VUvdtrav.c */
void VUvdtraverse V_P_((ADDRESS vdp, VUVDTRVRSFUNPTR fcn));

/* VU/VUvostd.c */
ATTRIBUTES *VUattrCreate V_P_((void));
void VUattrDelete V_P_((ATTRIBUTES *attr));
void VUattrPutFields V_P_((ATTRIBUTES *attr,  OBJECT *fg_clr,
	 OBJECT *bg_clr,  char *ln_width,  char *ln_type,  char *fill_status,
	 char *tx_dir,  char *tx_pos,  char *tx_font,  char *tx_size,  char *arc_dir,
	 char *crv_type,  char *tx_fname,  float *tx_width,  float *tx_height,
	 float *tx_angle,  float *tx_slant,  float *tx_char,  float *tx_line,
	 char *ob_name,  RECTANGLE *node_bounds,  char *edge_type,  char *prop_fill,
	 short *fill_amount));
void VUattrGetFields V_P_((ATTRIBUTES *attr,  OBJECT *fg_clr,
	 OBJECT *bg_clr,  char *ln_width,  char *ln_type,  char *fill_status,
	 char *tx_dir,  char *tx_pos,  char *tx_font,  char *tx_size,  char *arc_dir,
	 char *crv_type,  char **tx_fname,  float *tx_width,  float *tx_height,
	 float *tx_angle,  float *tx_slant,  float *tx_char,  float *tx_line,
	 char **ob_name,  RECTANGLE **node_bounds,  char *edge_type,
	 char *prop_fill,  short *fill_amount));
FLOAT_POINT *VUfloat_ptCreate V_P_((void));
void VUfloat_ptDelete V_P_((FLOAT_POINT *flt_pt));
void VUfloat_ptPutFields V_P_((FLOAT_POINT *flt_pt,  double x,
	 double y));
void VUfloat_ptGetFields V_P_((FLOAT_POINT *flt_pt,  float *x,
	 float *y));

/* VU/VUvplist.c */
RECTANGLE **VUvlCreate V_P_((RECTANGLE *invp,  RECTANGLE **outvps));
RECTANGLE **VUvlCopy V_P_((RECTANGLE **clipvps));
void VUvlDestroy V_P_((RECTANGLE **clipvps));

/* VU/VUwe.c */
void VUweReportEvent V_P_((WINEVENT *we, int level));

/* VU/VUxopen.c */
FILE *VUxopen V_P_((FILE *(*func)(),  char *filename,  char *type,
	 char *filepath,  int separator,  char **exp_name));

#endif /*VUMISCFUNS_H*/
